--- rtp.c.orig	Tue Mar 16 23:14:16 2004
+++ rtp.c	Wed Mar 17 01:04:05 2004
@@ -521,6 +521,10 @@
 			ast_log(LOG_NOTICE, "Unable to calculate samples for format %s\n", ast_getformatname(rtp->f.subclass));
 			break;
 		}
+		if(mark)
+			// reset previously recorded timestamp because
+			// sender had uses discontinous transmission
+			rtp->rxcore.tv_sec = rtp->rxcore.tv_usec = 0;
 		calc_rxstamp(&rtp->f.delivery, rtp, timestamp);
 	} else {
 		/* Video -- samples is # of samples vs. 90000 */
@@ -999,8 +1003,11 @@
 			   and if so, go with our prediction */
 			if (abs(rtp->lastts - pred) < 640)
 				rtp->lastts = pred;
-			else
+			else {
 				ast_log(LOG_DEBUG, "Difference is %d, ms is %d\n", abs(rtp->lastts - pred), ms);
+				/* Re-synchronize receiver, tell him to start new continuous segment */
+				mark = 1;
+			}
 		}
 	} else {
 		mark = f->subclass & 0x1;
